use std::fmt::Display;

use serde::Serialize;

#[derive(sqlx::Type, Debug, Clone, Copy, PartialEq, Eq, Serialize)]
#[sqlx(type_name = "function", rename_all = "lowercase")]
pub enum Function {
    Posten = 1,
    Wachhabender = 10,
}

impl Display for Function {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        match self {
            Function::Posten => write!(f, "Posten"),
            Function::Wachhabender => write!(f, "Wachhabender")
        }
    }
}

impl TryFrom<u8> for Function {
    type Error = ();

    fn try_from(value: u8) -> Result<Self, Self::Error> {
        match value {
            1 => Ok(Function::Posten),
            10 => Ok(Function::Wachhabender),
            _ => Err(()),
        }
    }
}
